/*
 * ASE1604.asm
 *
 *  Created: 16/06/2016 7.46.03
 *  Author: Roberto Roncella
 *  Compito del 13/06/2016
 *  Realizzare una subroutine per il microcontrollore AVR XMEGA256A3BU, 
 *  in grado di copiare blocchi di N byte dall'indirizzo A1 ad A2. 
 *  La subroutine trova N nella coppia di registri R1:R0 e i due indirizzi A1 e A2 
 *  rispettivamente nei puntatori X e Y. 
 *  La subroutine pu contare sul fatto che i byte del blocco originale e 
 *  della sua copia hanno tutti indirizzi validi.
 */ 
.EQU N=16
.EQU A1=0x2100
.EQU A2=0x2050
.EQU A2b=0x2150

test: //sezione di test della subroutine
 ldi R16,low(1024*8)
 ldi R17,high(1024*8)
 inc R17
 ldi ZL,low(0x2000)
 ldi ZH,high(0x2000)
lll:
 mov R18,ZL
 st Z+,R18
 dec R16
 brne lll
 dec R17
 brne lll

 ldi R16,low(N)
 ldi R17,high(N)
 movw R1:R0,R17:R16
 ldi XL,low(A1)
 ldi XH,high(A1)
 ldi YL,low(A2b)
 ldi YH,high(A2b)
 rcall Copy_block
 rjmp test

Copy_block:
 push R0 //salva i registri usati
 push R1
 push R16
 push XL
 push XH
 push YL
 push YH

 cp XL,YL
 cpc XH,YH
 breq end //non c'e' da fare nulla
 brcc loop_f //si puo' copiare avanzando

 add XL,R0 //in questo caso conviene copiare a partire dal fondo
 adc XH,R1
 add YL,R0
 adc YH,R1
 inc R1
l_r:
 ld R16,-X
 st -Y,R16
 dec R0
 brne l_r
 dec R1
 brne l_r
 rjmp end

loop_f:
 inc R1
l_f:
 ld R16,X+
 st Y+,R16
 dec R0
 brne l_f
 dec R1
 brne l_f

end:
 pop YH
 pop YL
 pop XH
 pop XL
 pop R16
 pop R1
 pop R0 //ripristina i registri usati
 ret 


